-- set a cost, 1 point per perk bonus, + total for traits, + gear(?)

ProfessionFramework.AlwaysUseStartingKits = true

local RandomCivSmallPistol = {}
for name, details in pairs(ORGM.Firearm.getTable()) do repeat
    if details.category ~= ORGM.REVOLVER and details.category ~= ORGM.PISTOL then break end
    if details.isCivilian ~= ORGM.COMMON and details.isCivilian ~= ORGM.RARE then break end
    table.insert(RandomCivSmallPistol, name)
    --print("adding ".. name .. " to RandomCivSmallPistol Table")
until true end

local selectRandomGun = function(player)
    local gunName = RandomCivSmallPistol[ZombRand(#RandomCivSmallPistol) +1]
    local details = ORGM.Firearm.getTable()[gunName]

    local item = InventoryItemFactory.CreateItem(details.moduleName.. "." ..gunName)
    ORGM.Firearm.setup(gunName, item)
    player:getInventory():AddItem(item)
    local ammoType = details.ammoType
    if details.clipData then
        ammoType = details.clipData.ammoType

        for i=1, ZombRand(3)+1 do
            player:getInventory():AddItem(details.clipData.moduleName .. "." .. details.ammoType)
        end
    end

    local altTable = ORGM.Ammo.getGroup(ammoType)
    if ZombRand(100) > 50 then
        ammoType = altTable[ZombRand(#altTable) +1]
    else
        ammoType = altTable[1]
    end
    details = ORGM.Ammo.getData(ammoType)

    for i=1, ZombRand(3)+1 do
        player:getInventory():AddItem(details.moduleName .. '.' .. ammoType .. "_Box")
    end

end


---------------------------------------------------------------------------------
ProfessionFramework.addProfession('sniper', {
    name = "UI_prof_sniper",
    icon = "profession_veteran2",
    cost = -10, -- should be -14
    xp = {
        [Perks.Aiming] = 3,
        [Perks.Reloading] = 2,
        [Perks.Sneak] = 2,
        [Perks.Lightfoot] = 1,
    },
    traits = {"ProfMilitary", "Inconspicuous2", "Graceful2", "Brave2", "Marksman"},
    inventory = {
        ["ORGM.SR25"] = 1,
        ["ORGM.SR25Mag"] = 2,
        ["ORGM.Ammo_762x51mm_FMJ_Box"] = 3,
    },
    OnNewGame = function(player, square, profession)
        local item = player:getInventory():FindAndReturn("ORGM.SR25")
        if not item then return end
        ORGM.Firearm.setup(ReloadUtil:getWeaponData(item:getType()), item)
        item:attachWeaponPart(InventoryItemFactory.CreateItem("ORGM.8xScope"))
        item:attachWeaponPart(InventoryItemFactory.CreateItem("ORGM.Rifsling"))
    end,
})

-----------------------------------------------------------------------------
ProfessionFramework.addProfession('unemployed', {
    cost = 8,
    inventory = {
        ["Base.NormalHikingBag"] = 1,
    },
    square = {},
    OnNewGame = function(player, square, profession)
        selectRandomGun(player)
        local perks = {
            Perks.Axe, Perks.Strength, Perks.Cooking, Perks.Doctor, Perks.Aiming, Perks.Reloading,
            Perks.Fishing, Perks.PlantScavenging, Perks.Farming, Perks.Woodwork, Perks.Nimble,
            Perks.Sneak, Perks.Lightfoot, Perks.Blunt, Perks.Sprinting, Perks.Fitness, Perks.Trapping,
            Perks.BladeGuard, Perks.BluntGuard, Perks.Electricity, Perks.BladeMaintenance, Perks.BluntMaintenance,
            Perks.MetalWelding
        }
        for i = 1, 4 do
            local perk = perks[ZombRand(#perks) +1]
            player:LevelPerk(perk)
            luautils.updatePerksXp(perk, player)
        end
    end,
})

ProfessionFramework.addProfession('fireofficer', {
    cost = -1, -- was 0
    xp = {
        [Perks.Sprinting] = 2,
        [Perks.Strength] = 1,
        [Perks.Fitness] = 2,
    },
    traits = {"ProfEmergency", "Brave2"},
    inventory = {
        ["Base.Axe"] = 1,
        ["Base.Extinguisher"] = 1,
        ["Radio.WalkieTalkie4"] = 1,
    },
})

ProfessionFramework.addProfession('policeofficer', {
    cost = -3, -- was - 4
    xp = {
        [Perks.Aiming] = 3,
        [Perks.Reloading] = 2,
        [Perks.Sprinting] = 2,
    },
    traits = {"ProfEmergency", "Brave2"},
    inventory = {
        ["ORGM.Ber92"] = 1,
        ["ORGM.Ber92Mag"] = 1,
        ["ORGM.Ammo_9x19mm_FMJ_Box"] = 2,
        ["Radio.WalkieTalkie4"] = 1,
    },
    OnNewGame = function(player, square, profession)
        local item = player:getInventory():FindAndReturn("ORGM.Ber92")
        if not item then return end
        ORGM.Firearm.setup(ReloadUtil:getWeaponData(item:getType()), item)
    end,
})

ProfessionFramework.addProfession('parkranger', {
    cost = -5, -- was -4
    xp = {
        [Perks.Trapping] = 2,
        [Perks.PlantScavenging] = 2,
        [Perks.Woodwork] = 2,
    },
    traits = {"ProfOutdoors", "Outdoorsman2"},
    recipes = {"Make Stick Trap", "Make Snare Trap", "Make Wooden Cage Trap", "Make Trap Box", "Make Cage Trap"},
    inventory = {
        ["ORGM.LENo4"] = 1,
        ["ORGM.LENo4Mag"] = 2,
        ["ORGM.Ammo_762x51mm_FMJ_Box"] = 3,
        ["Base.NormalHikingBag"] = 1,
    },
    square = {
        ["camping.CampingTentKit"] = 1,
        ["camping.CampfireKit"] = 1,
    },
    OnNewGame = function(player, square, profession)
        local item = player:getInventory():FindAndReturn("ORGM.LENo4")
        if not item then return end
        ORGM.Firearm.setup(ReloadUtil:getWeaponData(item:getType()), item)
        item:attachWeaponPart(InventoryItemFactory.CreateItem("ORGM.2xScope"))
        item:attachWeaponPart(InventoryItemFactory.CreateItem("ORGM.Rifsling"))
    end,
})

ProfessionFramework.addProfession('constructionworker', {
    cost = 2, -- was -2
    xp = {
        [Perks.Blunt] = 5,
        [Perks.Woodwork] = 1,
    },
    inventory = {
        ["Base.Sledgehammer"] = 1,
        ["Base.Saw"] = 1,
        ["Base.Screwdriver"] = 1,
        ["Base.Hammer"] = 1,
        ["Base.NailsBox"]  = 2,
    },
})

ProfessionFramework.addProfession('securityguard', {
    -- some revolver and flashlight
    cost = 5, -- was -2
    xp = {
        [Perks.Sprinting] = 2,
        [Perks.Lightfoot] = 1,
    },
    traits = {"NightOwl"},
    inventory = {
        ["Base.Torch"] = 1,
        ["Radio.WalkieTalkie3"] = 1,
    },
    OnNewGame = function(player, square, profession)
        selectRandomGun(player)
    end,
})

ProfessionFramework.addProfession('carpenter', {
    cost = 4, -- was 2
    xp = {
        [Perks.Woodwork] = 4,
    },
    inventory = {
        ["Base.Hammer"] = 2,
        ["Base.Saw"] = 1,
        ["Woodglue"] = 3,
        ["Base.NailsBox"] = 3,
    },
    square = {
        ["Base.Plank"] = 10,
    },
})

ProfessionFramework.addProfession('burglar', {
    cost = 2, -- was -6
    xp = {
        [Perks.Nimble] = 2,
        [Perks.Sneak] = 2,
        [Perks.Lightfoot] = 2,
    },
    inventory = {
        ["Base.Duffelbag"] = 2,
        ["Base.Crowbar"] = 1,
        ["Base.Torch"] = 1,
    },
    OnNewGame = function(player, square, profession)
        selectRandomGun(player)
    end,
})

ProfessionFramework.addProfession('chef', {
    cost = 0, -- was -4
    xp = {
        [Perks.Cooking] = 3,
        [Perks.BladeMaintenance] = 1,
        [Perks.Axe] = 1,
    },
    traits = {"Cook2"},
    recipes = {"Make Cake Batter", "Make Pie Dough", "Make Bread Dough"},
    inventory = {
        ["Base.KitchenKnife"] = 6,
        ["Base.Pot"] = 1,
        ["Base.Pan"] = 1,
        ["Base.Sausepan"] = 1,
        ["Base.RoastingPan"] = 1,
        ["Base.TinOpener"] = 1,
        ["Base.BakingPan"] = 1,
    },
    OnNewGame = function(player, square, profession)
        local knives = player:getInventory():FindAll("Base.KitchenKnife")
        if not knives then return end
        for i=1,knives:size() do
            local knife = knives:get(i-1)
            local upgrade = Tekagis.findUpgradeForItem(knife, "Fancy Kitchen Knife")
            Tekagis.upgradeItem(knife, upgrade, false)
        end
    end,

})

ProfessionFramework.addProfession('repairman', {
    cost = 3, -- was -4
    xp = {
        [Perks.Woodwork] = 1,
        [Perks.BladeMaintenance] = 2,
        [Perks.BluntMaintenance] = 2,
    },
    inventory = {
        ["Base.Screwdriver"] = 1,
        ["Base.Hammer"] = 1,
        ["Base.Glue"] = 2,
        ["Base.DuctTape"] = 4,
    },
})

ProfessionFramework.addProfession('farmer', {
    cost = 3, -- was 2
    xp = {
        [Perks.Farming] = 3,
    },
    traits = {"ProfOutdoors"},
    recipes = {"Make Mildew Cure", "Make Flies Cure"},
    inventory = {
        ["ORGM.Rem870"] = 1,
        ["ORGM.Ammo_12g_00Buck"] = 1,
        ["farming.CarrotBagSeed"] = 4,
        ["farming.BroccoliBagSeed"] = 4,
        ["farming.RedRadishBagSeed"] = 3,
        ["farming.StrewberrieBagSeed"] = 1,
        ["farming.TomatoBagSeed"] = 3,
        ["farming.PotatoBagSeed"] = 3,
        ["farming.CabbageBagSeed"] = 2,
        ["farming.HandShovel"] = 1,
        ["farming.Shovel"] = 1,
        ["farming.WateredCanFull"] = 1,
        ["farming.GardeningSprayFull"] = 1,
    },
    OnNewGame = function(player, square, profession)
        local item = player:getInventory():FindAndReturn("ORGM.Rem870")
        if not item then return end
        ORGM.Firearm.setup(ReloadUtil:getWeaponData(item:getType()), item)
        item:setCondition(5)
    end,
})

ProfessionFramework.addProfession('fisherman', {
    cost = 0, -- was -2
    xp = {
        [Perks.Fishing] = 3,
        [Perks.PlantScavenging] = 1,
    },
    traits = {"ProfOutdoors"},
    recipes = {"Make Fishing Rod", "Fix Fishing Rod", "Get Wire Back", "Make Fishing Net"},
    inventory = {
        ["Base.FishingLine"] = 4,
        ["Base.FishingNet"] = 3,
        ["Base.FishingRod"] = 1,
        ["Base.BaitFish"] = 10,
        ["Base.FishingTackle"] = 3,
        ["Base.FishingTackle2"] = 3,
        ["Base.Worm"] = 10,
    },
})

ProfessionFramework.addProfession('doctor', {
    cost = 3, -- was 2
    xp = {
        [Perks.Doctor] = 5,
    },
    traits = {"ProfEmergency"},
    inventory = {
        ["Base.Pills"] = 3,
        ["Base.PillsAntiDep"] = 3,
        ["Base.PillsBeta"] = 3,
        ["Base.PillsSleepingTablets"] = 3,
        ["Base.Scissors"] = 1,
        ["Base.AlcoholBandage"] = 1,
        ["Base.Disinfectant"] = 1,
        ["Base.Antibiotics"] = 1,
        ["Base.AlcoholWipes"] = 3,
        ["Base.FirstAidKit"] = 1,

        ["Base.SutureNeedle"] = 2,
        ["Base.AlcoholedCottonBalls"] = 1,
    },
})

ProfessionFramework.addProfession('veteran', {
    --name = getText("UI_prof_Veteran"),
    --icon = "profession_veteran2",
    cost = -6,-- -14
    xp = {
        [Perks.Aiming] = 4,
        [Perks.Reloading] = 4,
        [Perks.Sprinting] = 2,
    },
    traits = {"ProfMilitary", "Desensitized", "Outdoorsman2", "Insomniac2"},
    inventory = {
        ["ORGM.M16"] = 1,
        ["ORGM.STANAGMag"] = 2,
        ["ORGM.Ammo_556x45mm_FMJ_Box"] = 5,
        ["ORGM.Ber92"] = 1,
        ["ORGM.Ber92Mag"] = 1,
        ["ORGM.Ammo_9x19mm_FMJ_Box"] = 2,
    },
    OnNewGame = function(player, square, profession)
        local item = player:getInventory():FindAndReturn("ORGM.M16")
        if item then
            ORGM.Firearm.setup(ReloadUtil:getWeaponData(item:getType()), item)
        end
        item = player:getInventory():FindAndReturn("ORGM.Ber92")
        if not item then return end
        ORGM.Firearm.setup(ReloadUtil:getWeaponData(item:getType()), item)
    end,
})

ProfessionFramework.addProfession('nurse', {
    cost = 5, -- was 2
    xp = {
        [Perks.Doctor] = 2,
        [Perks.Lightfoot] = 1,
    },
    traits = {"ProfEmergency"},
    inventory = {
        ["Base.Pills"] = 1,
        ["Base.PillsAntiDep"] = 1,
        ["Base.PillsBeta"] = 1,
        ["Base.PillsSleepingTablets"] = 1,
        ["Base.Scissors"] = 1,
        ["Base.AlcoholBandage"] = 1,
        ["Base.Disinfectant"] = 1,
        ["Base.Antibiotics"] = 1,
        ["Base.AlcoholWipes"] = 3,
        ["Base.FirstAidKit"] = 1,
        ["Base.SutureNeedle"] = 2,
        ["Base.AlcoholedCottonBalls"] = 1,
        ["Base.Splint"] = 1,
    },
})

ProfessionFramework.addProfession('lumberjack', {
    cost = -2, -- was 0
    xp = {
        [Perks.Axe] = 3,
        [Perks.BladeMaintenance] = 2,
        [Perks.Strength] = 1,
    },
    traits = {"ProfOutdoors", "Axeman"},
    inventory = {
        ["Base.Axe"] = 2,
        ["Base.Saw"] = 1,
        ["Base.Rope"] = 2,
    },
    square = {
        ["Base.LogStacks4"] = 1,
    },
    OnNewGame = function(player, square, profession)
        local item = player:getInventory():FindAndReturn("ORGM.Axe")
        if not item then return end
        Tekagis.upgradeItem(item, Tekagis.findUpgradeForItem(item, "Hatchet"), false)
    end,
})

ProfessionFramework.addProfession('fitnessInstructor', {
    cost = -1, -- was -6,
    xp = {
        [Perks.Fitness] = 3,
        [Perks.Sprinting] = 2,
    },
    traits = {"Nutritionist2"},
    inventory = {
        ["Base.DigitalWatch2"] = 1,
        ["Base.PillsVitamins"] = 4,
        ["Base.BigHikingBag"] = 1,
        ["Base.WaterBottleFull"] = 6,
    },
})

ProfessionFramework.addProfession('burgerflipper', {
    cost = 5, -- was 2
    xp = {
        [Perks.Cooking] = 2,
        [Perks.BladeMaintenance] = 1,
    },
    traits = {"Cook2"},
    inventory = {
        ["Base.Burger"] = 10,
        ["Base.Fries"] = 10,
        ["Base.KitchenKnife"] = 4,
    },
})

ProfessionFramework.addProfession('electrician', {
    cost = -4, -- -4
    xp = {
        [Perks.Electricity] = 3,
    },
    recipes = {
        "Generator", "Make Remote Controller V1", "Make Remote Controller V2", "Make Remote Controller V3",
        "Make Remote Trigger", "Make Timer", "Craft Makeshift Radio", "Craft Makeshift HAM Radio", "Craft Makeshift Walkie Talkie"
    },
    inventory = {
        ["Base.Screwdriver"] = 1,
        ["Radio.ElectricWire"] = 3,
        ["Radio.RadioReceiver"] = 1,
        ["Radio.RadioTransmitter"] = 1,
        ["Radio.ScannerModule"] = 1,
        ["Base.MotionSensor"] = 1,
        ["Base.Speaker"] = 2,
        ["Base.Amplifier"] = 2,
        ["ElectronicsScrap"] = 4,
    },
})
ProfessionFramework.addProfession('mechanics', {
    cost = 0, -- -4
    xp = {
        [Perks.Electricity] = 1,
    },
})
ProfessionFramework.addProfession('engineer', {
    cost = 0, -- was -4
    xp = {
        [Perks.Electricity] = 1,
        [Perks.Woodwork] = 1,
        [Perks.MetalWelding] = 1,
    },
    recipes = { "Make Aerosol bomb", "Make Flame bomb", "Make Pipe bomb", "Make Noise generator", "Make Smoke Bomb", },
    inventory = {
        ["Base.NoiseTrap"] = 3,
        ["Base.SmokeBomb"] = 3,
        ["Base.PipeBomb"] = 3,
    },
})

ProfessionFramework.addProfession('metalworker', {
    cost = -2, -- was -6
    xp = {
        [Perks.MetalWelding] = 4,
    },
    recipes = { "Make Metal Walls", "Make Metal Fences", "Make Metal Containers", "Make Metal Sheet", "Make Small Metal Sheet", "Make Metal Roof" },
    inventory = {
        ["Base.BallPeenHammer"] = 1,
        ["Base.BlowTorch"] = 2,
        ["Base.MetalBar"] = 8,
    },
    square = {
        ["Base.SmallSheetMetal"] = 2,
        ["Base.WeldingMask"] = 1,
        ["Base.WeldingRods"] = 2,
    },
})


Events.OnGameBoot.Add(function()
    SurvivorDesc.addHairColor(ColorInfo.new(0, 0, 0, 1)) -- pure black
    SurvivorDesc.addHairColor(ColorInfo.new(1, 1, 1, 1)) -- white
    SurvivorDesc.addHairColor(ColorInfo.new(0.8, 0.8, 0.8, 1)) -- light grey
    SurvivorDesc.addHairColor(ColorInfo.new(0.4, 0.4, 0.4, 1)) -- dark grey

    --SurvivorDesc.addHairColor(ColorInfo.new(0, 1, 1, 1)) -- yellow
    SurvivorDesc.addHairColor(ColorInfo.new(1, 0, 0, 1)) -- red
    --SurvivorDesc.addHairColor(ColorInfo.new(1, 0.2, 0.2, 1)) -- pink
    --SurvivorDesc.addHairColor(ColorInfo.new(0, 1, 0, 1)) -- green
    --SurvivorDesc.addHairColor(ColorInfo.new(0.2, 1, 0.2, 1)) -- light greenish
    --SurvivorDesc.addHairColor(ColorInfo.new(0, 0, 1, 1)) -- blue
    --SurvivorDesc.addHairColor(ColorInfo.new(0.2, 0.2, 1, 1)) -- light blue
    --SurvivorDesc.addHairColor(ColorInfo.new(1, 0, 1, 1)) -- purple
end)
